/*
  psfig.c
           Produced by Takashi Nagashima	(Mukizaiken)	1992/8/XX
	                                         tanagash@MIX


         <Changes>
	     (ecl)epsf.sty & epsbox.sty  support
		                           by  Kazumasa Gotoh 1993/3/XX
					       kgotoh@MIX
					       kgotoh@biwa.juice.or.jp

             Ĺ epsbox.sty ݡȤȤ̤Ʊ (ecl)epsf.sty
	      epsbox.sty ΥݡȺȤԤʤä
	     ĹΥѥå˥ޡ٤ʤΤǤ
	     ˤޡƤޤ (^_^;


   #################### GhostScript ######################################

   Copyright (C) 1989, 1992 Aladdin Enterprises.  All rights reserved.
   Distributed by Free Software Foundation, Inc.
   #######################################################################

   ############ Psfig #########################################################
   All software, documentation, and related files in this distribution of
   psfig/tex are Copyright (c) 1987 Trevor J. Darrell

   Permission is granted for use and non-profit distribution of psfig/tex 
   providing that this notice be clearly maintained, but the right to
   distribute any portion of psfig/tex for profit or as part of any commercial
   product is specifically reserved for the author.
   ############################################################################

*/

#include	<stdio.h>
#include	<string.h>
#include	<ctype.h>
#include	"config.h"
#include	"drive.h"

#ifdef	PSFIG

#include	"psfig.h"

#ifndef	TRUE
#define	TRUE	1
#endif
#ifndef	FALSE
#define	FALSE	0
#endif

#define	PSFIG_TEX	0	/* added by kgotoh */
#define	EPSF_STY	1	/* added by kgotoh */
#define	EPSBOX_STY	2	/* added by kgotoh */

#define	PSFIG_INIT	0
#define	PSFIG_INCLUDE	1
#define	PSFIG_LITERAL	2
#define	PSFIG_NONE	(-1)

#define	MAXFILENAMELEN	256

#if	MSDOS
#define	FSC	'\\'
#define	FSS	"\\"
#define	PSC	';'
#else
#define	FSC	'/'
#define	FSS	"/"
#define	PSC	':'
#endif

/*
  Japanese (EUC code)

  ENV_PSFIGPSDIR	ݥȥץȥեθѥδĶѿ̾롣
                        δĶѿꤵƤʤСѥ lips3dvi.cnf 
			psfigpsdir ȥ꡼ʤ PSFIGPSDIR 
			ǽŪ˺Ѥ롣θѥŬѤΤ PSFIG_HEADER, 
			PSFIG_TAILER, PSFIG_PRO  EPSF ե롣

  ENV_PSFIGTMPDIR	ƥݥ꡼եѤΥѥĶѿ롣
                        δĶѿꤵƤʤСlips3dvi.cnf  psfigtmpdir ȥ꡼
			ʤPSFIGTMPDIR ǽŪ
			˺Ѥ롣ѥϡѥΤ褦ʣƤϤʤ
			ΥѥϡPSFIG_TMPFILE  PSFIG_RASTER ŬѤ롣

  PSFIGPSDIR		ǥեȤΥݥȥץȥեθѥ
                        ɬȥǥ쥯ȥǤ '.' ޤޤƤ

  PSFIGTMPDIR		ǥեȤΥƥݥ꡼եѥ

  PSFIG_HEADER		Psfig ȥ󥿡ե뤿Ρإå

  PSFIG_TAILER		Psfig 򴰷뤵뤿Ρüե롣

  PSFIG_PRO		Psfig Ѥե롣

  PSFIG_TMPFILE		GhostScript ϥե롣

  PSFIG_RASTER		GhostScript νϥե롣
  
*/
#ifndef	ENV_PSFIGPSDIR
#  define	ENV_PSFIGPSDIR		"PSFIGPSDIR"
#endif

#ifndef	ENV_PSFIGTMPDIR
#  define	ENV_PSFIGTMPDIR		"PSFIGTMPDIR"
#endif

#ifndef	PSFIGPSDIR
#  define	PSFIGPSDIR	"."
#endif
#ifndef	PSFIGTMPDIR
#  define	PSFIGTMPDIR	"."
#endif
#ifndef	PSFIG_TMPFILE
#  define	PSFIG_TMPFILE	"psfig.tmp"
#endif

#ifndef	PSFIG_HEADER
#  define	PSFIG_HEADER	"psfig.hdr"
#endif

#ifndef	PSFIG_TAILER
#  define	PSFIG_TAILER	"psfig.tlr"
#endif

#ifndef	PSFIG_PRO
#  define	PSFIG_PRO	"psfig.pro"
#endif

#ifndef	PSFIG_RASTER
#  define	PSFIG_RASTER	"psfig.ras"
#endif


/* PSFIG Temporary File */
static char	*PSFIGtmpfile = PSFIG_TMPFILE;
static char	PSFIGtmpfullpath[MAXFILENAMELEN];
static char	*PSFIGrasterfile = PSFIG_RASTER;
static char	PSFIGrasterfullpath[MAXFILENAMELEN];


/* PSFIG Program File (Header or Tailer) */
static char	*PSFIGheader = PSFIG_HEADER;
static char	*PSFIGtailer = PSFIG_TAILER;

static char	*PSFIGpro = PSFIG_PRO;


typedef struct {
    char	*keystr;
    int		key;
    int		with_s;
}	Special_Key;

static Special_Key
special_key[] = {
    /*** psfig.tex for dvi2ps ***/
    {"PS: psfiginit", PSFIG_INIT, FALSE},
    {"PS: include", PSFIG_INCLUDE, TRUE},
    {"PS: literal", PSFIG_LITERAL, TRUE},
    /*** psfig.tex for dvips ***/
    {"ps::[begin]", PSFIG_LITERAL, TRUE},
    {"ps::[end]", PSFIG_LITERAL, TRUE},
    {"ps: plotfile", PSFIG_INCLUDE, TRUE},
    {"ps::", PSFIG_LITERAL, TRUE},
    {NULL, PSFIG_NONE, 0}
};

extern char	*getenv();


static char	*
physicalpath(path)
    char	*path;
{
    register char	*p; 
    static char		buf[MAXFILENAMELEN];

    strcpy(buf, path);
    p = buf;
#if	MSDOS
    while (*p != 0) {
	if (*p == '/')
	    *p = '\\';
	p++;
    }
#endif
    return buf;
}

static int
parse_special(str, args)
    char	*str;
    char	*args;
{
    Special_Key	*sk;
    int		t;
    
    for ( ; *str == ' '; str++)
	;
    for (sk = special_key; sk->key != PSFIG_NONE; sk++)
	if (strncmp(sk->keystr, str, strlen(sk->keystr)) == 0)
	    break;

    if (sk->key == PSFIG_NONE)
	return (PSFIG_NONE);

    if (sk->with_s == FALSE) {
	*args = '\0';
	return (sk->key);
    }

    str += strlen(sk->keystr);
    for ( ; *str == ' '; str++)
	;
    if (*str == '\'' || *str == '\"')
	t = *str++;
    else
	t = ' ';
    for ( ; *str != t && *str != 0; *args++ = *str++)
	;
    *args = '\0';

    return (sk->key);
}


#if	MSDOS
#  define	bcopy(b1, b2, len)	memcopy(b2, b1, len)
#endif

static void
makefullpath(full, path, name)
    char	*full;
    char	*path;
    char	*name;
{
    bcopy(path, full, strlen(path) + 1);
    if (path[strlen(path) - 1] != '/' )
	strcat(full, "/");
    strcat(full, name);
}


static char *
testaccess(name)
    char	*name;
{
    char	*path;
    static char	fullpath[MAXFILENAMELEN];

    if (((path = getenv(ENV_PSFIGPSDIR)) == NULL) && ((path = psfigpsdir) == NULL))
	path = PSFIGPSDIR;

#if	MSDOS
    if (name[0] == '/' || (isalpha(name[0]) && name[1] == ':' && name[2] == '/'))
#else
    if (name[0] == '/')
#endif
    {
	strcpy(fullpath, name);
	return ((access(physicalpath(fullpath), 0x04) == 0) ? fullpath : NULL);
    }
    else {
	char	*p;

	while (*path != '\0') {
	    if ((p = strchr(path, ';')) != NULL) {
		strncpy(fullpath, path, p - path);
		fullpath[p - path] = '\0';
		path = p + 1;
	    }
	    else {
		strcpy(fullpath, path);
		path += strlen(path);
	    }
	    makefullpath(fullpath, fullpath, name);
	    if (access(physicalpath(fullpath), 0x04) == 0)
		return (fullpath);
	}
    }

    return (NULL);
}


static FILE *
openPSfile(file)
    char	*file;
{
    char	*p;

    if ((p = testaccess(file)) == NULL)
	return (NULL);

    return (fopen(physicalpath(p), "r"));
}


static int
copyfile(wfp, psfile)
    FILE	*wfp;
    char	*psfile;
{
    FILE	*rfp;
    char	*p;
    int		c;

    if ((rfp = openPSfile(psfile)) == NULL) {
	fprintf(stderr, "FILE: %s not found ...\n", psfile);
	return (TRUE);
    }

    while ((c = getc(rfp)) != EOF)
	putc(c, wfp);

    fclose(rfp);
    return (FALSE);
}


static int
get1char(fp)
    FILE	*fp;
{
    return (getc(fp));
}

static int4
get4char(fp)
    FILE	*fp;
{
    register int4	x = get1char(fp);

    x = (x << 8) | get1char(fp);
    x = (x << 8) | get1char(fp);
    x = (x << 8) | get1char(fp);

    return x;
}


int
get_GSrasterchar(rasfp)
    FILE	*rasfp;
{
    register int	c;
    static int	savechar = -1;
    static int	savecnt = 0;
    static int	unget1char = -1;

    if (savecnt > 0) {
	savecnt--;
	return savechar;
    }
    
    if (unget1char < 0)
	c = get1char(rasfp);
    else
	c = unget1char;

    if ( c == EOF)
	return EOF;

    unget1char = get1char(rasfp);
    if (c == unget1char) {
	unget1char = -1;
	if ((savecnt = get1char(rasfp)) == EOF)
	    return EOF;
	savecnt--;
	savechar = c;
    }
    return c;
}

    
static FILE	*psfp;

static int
psfig_include(file)
    char	*file;
{
    if (verbose)
	fprintf(stderr, "%s ", file);
    return (copyfile(psfp, file));
}    

static int
psfig_start(x, y)
    int4	x;
    int4	y;
{
    double xres = (double) gsprops.xres;
    double yres = (double) gsprops.yres;		
    int4	width = (int4)((double)x / 65536.0 / 72.27 * xres + 0.5);
    int4	height = (int4)((double)y / 65536.0 / 72.27 * yres + 0.5);
    char	*path;

    if (((path = getenv(ENV_PSFIGTMPDIR)) == NULL) && ((path = psfigtmpdir) == NULL))
	path = PSFIGTMPDIR;
    makefullpath(PSFIGtmpfullpath, path, PSFIGtmpfile);
    makefullpath(PSFIGrasterfullpath, path, PSFIGrasterfile);

    if ((psfp = fopen(physicalpath(PSFIGtmpfullpath), "w")) == NULL) {
	fprintf(stderr, "FILE: %s not created ...\n", PSFIGtmpfullpath);
	return TRUE;
    }
    
    if (verbose)
	fprintf(stderr, "{ Psfig: %s( ", PSFIGtmpfullpath);
    /*
     * ƥݥ꡼ʥݥȥץȥե
     * إåʬ
     */
    fprintf(psfp, "%%!\n");
    fprintf(psfp, "/PSFIGwidth %ld def\n", width);
    fprintf(psfp, "/PSFIGheight %ld def\n", height);
    fprintf(psfp, "/PSFIGxres %.0lf def\n", xres);
    fprintf(psfp, "/PSFIGyres %.0lf def\n", yres);
    copyfile(psfp, PSFIGheader);
    copyfile(psfp, PSFIGpro);
    
    if (verbose) {
	fprintf(stderr, "%s ", PSFIGheader);
	fprintf(stderr, "%s ", PSFIGpro);
    }
    return FALSE;
}


/*
 * GhostScript ưEPSFե饹饤롣
 * η̤ rasinfo.raster Ͽ롼Ϥ
 */
static int
psfig_end(h, v)
    int4	h, v;
{
    char	com[256];
    int	i;
    FILE	*rasfp;
    static RasInfo	rasinfo;

    copyfile(psfp, PSFIGtailer);
    fclose(psfp);

    rasinfo.h = h;
    rasinfo.v = v;

    if (verbose)
	fprintf(stderr, "%s ) ", PSFIGtailer);

    /* 
     * GhostScriptưޥ: gs 
     *   gs -sDEVICE=psfig -sOUTPUTFILE=psfig.ras -q -dNOPAUSE -- psfig.tmp
     */
    sprintf(com, "gs -sDEVICE=psfig -sOUTPUTFILE=%s -q -dNOPAUSE -- ",
	    physicalpath(PSFIGrasterfullpath));
    strcat(com, physicalpath(PSFIGtmpfullpath));
    
    if (verbose)
	fprintf(stderr, "*gs* ");

    if ((i = system(com)) == 0x7f || i == 0x7f00) {
	fprintf(stderr, "\'gs\' can not execute ...\n");
	return TRUE;
    }

    if (verbose)
	fprintf(stderr, "%s ", PSFIGrasterfullpath);

    /*
     * 饹եץ󥿡ؤνϥ롼Ϥ
     * ѤΥ롼ϥǥХ¸Τᡢlbp.c  lp3000.c ɲäƤ롣
     */
    if ((rasfp = fopen(physicalpath(PSFIGrasterfullpath), "r")) == NULL) {
	fprintf(stderr, "FILE: %s not found ...\n", PSFIGrasterfullpath);
	return TRUE;
    }	

    unlink(PSFIGtmpfullpath);
    unlink(PSFIGrasterfullpath);

    if (verbose)
	fprintf(stderr, "*printing* ");

    (void)get4char(rasfp);	/* skip ID */
    (void)get4char(rasfp);	/* skip */
    (void)get4char(rasfp);	/* skip */
    (void)get4char(rasfp);	/* skip */
    (void)get4char(rasfp);	/* skip */
    rasinfo.width = get4char(rasfp);
    rasinfo.height = get4char(rasfp);
    rasinfo.total = get4char(rasfp);
    fseek(rasfp, 128L, 0);	/* skip header */
    (*gsprops.raster)(&rasinfo, rasfp);
    fclose(rasfp);
    
    if (verbose)
	fprintf(stderr, "}");
    return FALSE;
}	


int
dospecial(h, v, len, str)
    int4	h;
    int4	v;
    int		len;
    char	*str;
{
    char	buf[256];
    char	com[256];
    char	*p;
    int4	x, y, llx, lly, urx, ury;
    int		endTexFig = FALSE;
    double	hsize, vsize, llx_f, lly_f, urx_f, ury_f; /* added by kgotoh */
    int		type = PSFIG_TEX;			  /* added by kgotoh */
    char	epsfile[BUFSIZ];			  /* added by kgotoh */

    switch (parse_special(str, buf)) {

    case PSFIG_INIT:
	break;

    case PSFIG_INCLUDE:
	return psfig_include(buf);
	break;

    case PSFIG_LITERAL:
	if (sscanf(buf, "%ld%ld%ld%ld%ld%ld%s", &x, &y, &llx, &lly, &urx, &ury, com) == 7 && 
	    strcmp(com, "startTexFig") == 0) {
	    if (psfig_start(x, y))
		return TRUE;
	}
	else if (sscanf(buf, "%s", com) == 1 && strcmp(com, "endTexFig") == 0)
	    endTexFig = TRUE;
	
	fprintf(psfp, "%s\n", buf);
	break;

    default:	/* added by kgotoh */
	if ((type = other_special_parse(str, epsfile, &hsize, &vsize)) != 0) {
	    if (get_bounding_box(epsfile,
				 &llx_f, &lly_f, &urx_f, &ury_f, &type)) {
		x = (int4)(hsize * 66536.0 + 0.5);
		y = (int4)(vsize * 66536.0 + 0.5);
		if (psfig_start(x, y) == 0) {
		    fprintf(psfp, "%ld %ld %ld %ld %ld %ld startTexFig \n",
			    x, y,
			    (int4)(llx_f / 72.0 * 72.27 * 66536.0 + 0.5),
			    (int4)(lly_f / 72.0 * 72.27 * 66536.0 + 0.5),
			    (int4)(urx_f / 72.0 * 72.27 * 66536.0 + 0.5),
			    (int4)(ury_f / 72.0 * 72.27 * 66536.0 + 0.5));
		    if (psfig_include(epsfile) == 0) {
			fprintf(psfp, "endTexFig \n");
			if (type == EPSBOX_STY)
			    v -= y;
			endTexFig = TRUE;
		    }
		    else return TRUE;
		}
		else return TRUE;
	    }
	    else return TRUE;
	}
	else fprintf(stderr, "* unnokwn special name = [%s]\n", str);
	break;
    }

    if (endTexFig)
	if (psfig_end(h, v))
	    return TRUE;

    return FALSE;
}


/* ************************************************************
 *
 * 1993/3/??
 *	'epsf' suport by Kazumasa Gotoh
 *				kgotoh@MIX
 *				kgotoh@biwa.juice.or.jp
*/
static	int
other_special_parse(str, epsfile, hsize, vsize)
  char		*str;
  char		*epsfile;
  double	*hsize;
  double	*vsize;
{
    char	*ptr;
    int		type;

    if (strncmp(str, "epsfile", strlen("epsfile")) == 0) {
	type = EPSF_STY;
	ptr = strtok(str, " =");
	strcpy(epsfile, strtok(NULL, " "));
	ptr = strtok(NULL, " =");
	while(ptr != NULL) {
	    if (strcmp(ptr, "hsize") == 0) {
		ptr = strtok(NULL, " ");
		sscanf(ptr, "%lf", hsize);
	    }
	    else {
		if (strcmp(ptr, "vsize") == 0) {
		    ptr = strtok(NULL, " ");
		    sscanf(ptr, "%lf", vsize);
		}
		else return 0;
	    }
	    ptr = strtok(NULL, " =");
	}
    }
    else {
	if (strncmp(str, "postscriptbox", strlen("postscriptbox")) == 0) {
	    type = EPSBOX_STY;
	    ptr = strtok(str, "{}");
	    ptr = strtok(NULL, "{}");
	    sscanf(ptr, "%lf", hsize);
	    ptr = strtok(NULL, "{}");
	    sscanf(ptr, "%lf", vsize);
	    strcpy(epsfile, strtok(NULL, "{}"));
	}
	else return 0;
    }

    return type;
}

static	int
get_bounding_box(epsfile, llx, lly, urx, ury)
  char		*epsfile;
  double	*llx;
  double	*lly;
  double	*urx;
  double	*ury;
{
    FILE*	fptr;
    char	buf[BUFSIZ];

    if ((fptr = openPSfile(epsfile)) == NULL) {
	strcat(epsfile, ".ps");
	if ((fptr = openPSfile(epsfile)) == NULL) {
	    fprintf(stderr, "Unable to open file %s\n", epsfile);
	    perror(epsfile);
	    return FALSE;
	}
    }

    do {
	if (fgets(buf, BUFSIZ, fptr) == NULL) {
	    fprintf(stderr, "%s:unexpected EOF.\n", epsfile);
	    return FALSE;
	}
	if (strncmp(buf, "%%BoundingBox:", 14) == 0) {
	    sscanf(buf + 14, "%lf %lf %lf %lf", llx, lly, urx, ury);
	    break;
	}
    }	while(1);

    fclose(fptr);

    return TRUE;
}

#endif	/* PSFIG */
